import IHTMLAnchorElement from '../nodes/html-anchor-element/IHTMLAnchorElement.js';
import IHTMLElement from '../nodes/html-element/IHTMLElement.js';
import IHTMLAudioElement from '../nodes/html-audio-element/IHTMLAudioElement.js';
import IHTMLBaseElement from '../nodes/html-base-element/IHTMLBaseElement.js';
import IHTMLTemplateElement from '../nodes/html-template-element/IHTMLTemplateElement.js';
import IHTMLFormElement from '../nodes/html-form-element/IHTMLFormElement.js';
import IHTMLInputElement from '../nodes/html-input-element/IHTMLInputElement.js';
import IHTMLTextAreaElement from '../nodes/html-text-area-element/IHTMLTextAreaElement.js';
import IHTMLScriptElement from '../nodes/html-script-element/IHTMLScriptElement.js';
import IHTMLImageElement from '../nodes/html-image-element/IHTMLImageElement.js';
import IHTMLLinkElement from '../nodes/html-link-element/IHTMLLinkElement.js';
import IHTMLStyleElement from '../nodes/html-style-element/IHTMLStyleElement.js';
import IHTMLLabelElement from '../nodes/html-label-element/IHTMLLabelElement.js';
import IHTMLSlotElement from '../nodes/html-slot-element/IHTMLSlotElement.js';
import IHTMLMetaElement from '../nodes/html-meta-element/IHTMLMetaElement.js';
import IHTMLButtonElement from '../nodes/html-button-element/IHTMLButtonElement.js';
import IHTMLDialogElement from '../nodes/html-dialog-element/IHTMLDialogElement.js';
import IHTMLIFrameElement from '../nodes/html-iframe-element/IHTMLIFrameElement.js';
import IHTMLOptGroupElement from '../nodes/html-opt-group-element/IHTMLOptGroupElement.js';
import IHTMLOptionElement from '../nodes/html-option-element/IHTMLOptionElement.js';
import IHTMLSelectElement from '../nodes/html-select-element/IHTMLSelectElement.js';
import IHTMLVideoElement from '../nodes/html-video-element/IHTMLVideoElement.js';

// Makes it work with custom elements when they declare their own interface.
declare global {
	/* eslint-disable @typescript-eslint/naming-convention */
	/* eslint-disable @typescript-eslint/no-empty-interface */
	interface HTMLElementTagNameMap {}
	/* eslint-enable @typescript-eslint/naming-convention */
	/* eslint-enable @typescript-eslint/no-empty-interface */
}

export default interface IHTMLElementTagNameMap extends HTMLElementTagNameMap {
	a: IHTMLAnchorElement;
	abbr: IHTMLElement;
	address: IHTMLElement;
	area: IHTMLElement;
	article: IHTMLElement;
	aside: IHTMLElement;
	audio: IHTMLAudioElement;
	b: IHTMLElement;
	base: IHTMLBaseElement;
	bdi: IHTMLElement;
	bdo: IHTMLElement;
	blockquaote: IHTMLElement;
	body: IHTMLElement;
	template: IHTMLTemplateElement;
	form: IHTMLFormElement;
	input: IHTMLInputElement;
	textarea: IHTMLTextAreaElement;
	script: IHTMLScriptElement;
	img: IHTMLImageElement;
	link: IHTMLLinkElement;
	style: IHTMLStyleElement;
	label: IHTMLLabelElement;
	slot: IHTMLSlotElement;
	meta: IHTMLMetaElement;
	blockquote: IHTMLElement;
	br: IHTMLElement;
	button: IHTMLButtonElement;
	canvas: IHTMLElement;
	caption: IHTMLElement;
	cite: IHTMLElement;
	code: IHTMLElement;
	col: IHTMLElement;
	colgroup: IHTMLElement;
	data: IHTMLElement;
	datalist: IHTMLElement;
	dd: IHTMLElement;
	del: IHTMLElement;
	details: IHTMLElement;
	dfn: IHTMLElement;
	dialog: IHTMLDialogElement;
	div: IHTMLElement;
	dl: IHTMLElement;
	dt: IHTMLElement;
	em: IHTMLElement;
	embed: IHTMLElement;
	fieldset: IHTMLElement;
	figcaption: IHTMLElement;
	figure: IHTMLElement;
	footer: IHTMLElement;
	h1: IHTMLElement;
	h2: IHTMLElement;
	h3: IHTMLElement;
	h4: IHTMLElement;
	h5: IHTMLElement;
	h6: IHTMLElement;
	head: IHTMLElement;
	header: IHTMLElement;
	hgroup: IHTMLElement;
	hr: IHTMLElement;
	html: IHTMLElement;
	i: IHTMLElement;
	iframe: IHTMLIFrameElement;
	ins: IHTMLElement;
	kbd: IHTMLElement;
	legend: IHTMLElement;
	li: IHTMLElement;
	main: IHTMLElement;
	map: IHTMLElement;
	mark: IHTMLElement;
	math: IHTMLElement;
	menu: IHTMLElement;
	menuitem: IHTMLElement;
	meter: IHTMLElement;
	nav: IHTMLElement;
	noscript: IHTMLElement;
	object: IHTMLElement;
	ol: IHTMLElement;
	optgroup: IHTMLOptGroupElement;
	option: IHTMLOptionElement;
	output: IHTMLElement;
	p: IHTMLElement;
	param: IHTMLElement;
	picture: IHTMLElement;
	pre: IHTMLElement;
	progress: IHTMLElement;
	q: IHTMLElement;
	rb: IHTMLElement;
	rp: IHTMLElement;
	rt: IHTMLElement;
	rtc: IHTMLElement;
	ruby: IHTMLElement;
	s: IHTMLElement;
	samp: IHTMLElement;
	section: IHTMLElement;
	select: IHTMLSelectElement;
	small: IHTMLElement;
	source: IHTMLElement;
	span: IHTMLElement;
	strong: IHTMLElement;
	sub: IHTMLElement;
	summary: IHTMLElement;
	sup: IHTMLElement;
	table: IHTMLElement;
	tbody: IHTMLElement;
	td: IHTMLElement;
	tfoot: IHTMLElement;
	th: IHTMLElement;
	thead: IHTMLElement;
	time: IHTMLElement;
	title: IHTMLElement;
	tr: IHTMLElement;
	track: IHTMLElement;
	u: IHTMLElement;
	ul: IHTMLElement;
	var: IHTMLElement;
	video: IHTMLVideoElement;
	wbr: IHTMLElement;
}
